package tech.mercantec.easyeat.helpers

import android.content.Context
import kotlinx.serialization.Serializable
import tech.mercantec.easyeat.models.ShoppingListItem

fun getShoppingList(ctx: Context): Array<ShoppingListItem> {
    return requestJson<Unit, Array<ShoppingListItem>>(ctx, "GET", "/api/ShoppingList/get", null)
}

@Serializable
data class AddShoppingItemRequest(val name: String, val amount: Double?, val unit: String?, val checked: Boolean)

fun addShoppingItem(ctx: Context, name: String, amount: Double?, unit: String?) {
    val request = AddShoppingItemRequest(name, amount, unit, false)

    requestJson<AddShoppingItemRequest, Boolean>(ctx, "POST", "/api/ShoppingList/add", request)
}

fun toggleShoppingItemChecked(ctx: Context, item: ShoppingListItem) {
    requestJson<Unit, Boolean>(ctx, "PUT", "/api/ShoppingList/check?itemId=${item.id}", null)
}
